﻿MorgBid2 = LibStub("AceAddon-3.0"):NewAddon("MorgBid2", "AceComm-3.0", "AceConsole-3.0", "AceSerializer-3.0", "AceEvent-3.0", "AceTimer-3.0")
local media = LibStub("LibSharedMedia-3.0", true)
local C = LibStub("AceConfigDialog-3.0")
local CC = LibStub("AceConfigCmd-3.0")

local L = LibStub("AceLocale-3.0"):GetLocale("MorgBid2")

local bid = { }
local bidstep = 5
local BIDWAR
local BIDWARSILENT = {}
local HasBID = {}
local TAKEBID
local RANDOM = {}
local ALLOWNEED = 0
local ATTENDANCE = 0
local SCANNING
local WEIGHRAND
local db
local dkp = 0
local frames = { }
local dkpframes = {}
local itemlist = {}
local otherbids = {}
local origbid = {}
local overbid = 0
local mintakebid = 0
local Player = UnitName("player")
local CombatLockdown
local MONITORLOOTING = nil
local SILENT = {}
local QUALITYLEVEL = 4
local trycount = {}
local MemberDKP = {}
local DKPLIST
local NEED = L["NEED"]
local TAKE = L["TAKE"]
local OFFSPEC = L["OFFSPEC"]
local PASS = L["PASS"]
local LOOT_SELF_REGEX = gsub(LOOT_ITEM_SELF, "%%s", "(.+)")
local LOOT_REGEX = gsub(LOOT_ITEM, "%%s", "(.+)")
local format = string.format
local MorgBid2_Options
local versionstring = "v5.5"
local version = 110
MorgBid2.versionstring = versionstring
local statustext
local tinsert = table.insert
local tremove = table.remove
local floor = math.floor

local Quality = {[1] = {.6, .6, .6},
		[2] =  {1, 1, 1},
		[3] = {0, 1, 0},
		[4] = {0, .5, 1},
		[5] = {.7, .46, 1},
		[6] = {1, .5, 0},
		[7] = {.9, .8, .5}
}
	

local defaults = { 
	profile = {
		point = "CENTER",
		relpoint = "CENTER",
		x = 0,
		y = 0,
		alwaysresult = nil,
		anchorpoint = "CENTER",
		anchorrelpoint = "CENTER",
		anchorx = 0,
		anchory = 0,
		hints = nil,
		result = true,
		resultheight = 35,
		resultgrow = 4,
		autoclose = true,
		lockdown = nil,
		bidheight = 10,
		media = {
    			font = "Friz Quadrata TT",
    			fontsize = 7,
    			border = "Blizzard Tooltip",
	    		background = "Blizzard Out of Control",
			backdropC = { .58, .58, .58, 1},
			borderC = { .96, .93, .26, .75 },
			resultfont = "Friz Quadrata TT",
    			resultfontsize = 7,
    			resultpoint = "TOPLEFT",
    			resultrelpoint = "BOTTOMLEFT"
    		},
	},
}

function MorgBid2:OnInitialize()
	--saved variables and config options
	self.db = LibStub("AceDB-3.0"):New("MorgBid2DB", defaults, "Default")
	if AddonLoader and SlashCmdList["MORGBID2"] then SlashCmdList["MORGBID2"] = nil end
	self:RegisterChatCommand("morgbid2", "LoadOptionsSlash")
end

function MorgBid2:OnEnable()
	db = self.db.profile
	self:RestoreStatusText()
	self:RegisterComm("MorgBid2", "OnCommReceive")
	self:RegisterComm("MorgDKP2MorgBid", "OnMorgBidCommReceive")
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "StartCombat")
	self:RegisterEvent("PLAYER_REGEN_ENABLED", "EndCombat")
	if AddonLoader and InterfaceOptionsFrame:IsShown() and not MorgBid2_Options then self:LoadOptions() end
	self.scanQ = {}
end

function MorgBid2:OnDisable()
	
end

function MorgBid2:LoadOptions()
	if not MorgBid2_Options then
		local _, _, _, enabled = GetAddOnInfo("MorgBid2_Options")
		if enabled then
			local success, fail = LoadAddOn("MorgBid2_Options")
			if not success then 
				self:debug("Options loading failed because "..fail) 
				return
			end
		else
			self:debug("Please enable MorgBid2_Options")
			return 
		end
	end
	MorgBid2_Options = LibStub("AceAddon-3.0"):GetAddon("MorgBid2_Options")
end

function MorgBid2:LoadOptionsSlash()
	self:LoadOptions()
	if not C.OpenFrames["MorgBid2"] then C:Open("MorgBid2") end
end

function MorgBid2:OnProfileChanged()
	db = self.db.profile
	self:UpdateFrameMedia()
	self:UpdateResultMedia()
	MorgBid2_Options:OnProfileChanged()
end

function MorgBid2:debug(message)
	if self.db.profile.devmode then
		MorgBid2:Print(message)
	end
end

function MorgBid2:StartCombat()
	CombatLockdown = true
end

function MorgBid2:EndCombat()
	CombatLockdown = nil
end

function MorgBid2:RestoreStatusText()
	statustext = {	["NEED"] = {n = NEED, r = 0, g = 1, b = 0},
			["PASS"] = {n = PASS, r = 1, g = 0, b = 0},
			["TAKE"] = {n = TAKE, r = 0, g = .7, b = 0},
			["OFFSPEC"] = {n = OFFSPEC, r = 0, g = .5, b = 0},
			["PENDING"] = {n = L["PENDING"], r = 1, g = 1, b = 0},
			["NONE"] = {n = L["NONE"], r = 1, g = 0, b = 0},
			["BID"] = {n = L["BID"], r = 0, g = 1, b = 0},
	}
end

function MorgBid2:ToggleLootEvent(ON)
	if ON then 
		self:debug("Enabling Loot event")
		self:RegisterEvent("CHAT_MSG_LOOT", "OnLootMsg")
		self.Loottimer = self:ScheduleTimer("DisableLootMonitor", 600)
	else self:UnregisterEvent("CHAT_MSG_LOOT") end
end

function MorgBid2:DisableLootMonitor()
	self:debug("Disabling Loot event")
	MONITORLOOTING = nil
	self:ToggleLootEvent()
end

function MorgBid2:OnLootMsg(_, lootmsg)
	if not UnitInRaid("player") then
		self:DisableLootMonitor()
		return 
	end
	local _, _, sPlayer, itemlink = string.find(lootmsg, LOOT_REGEX)
  	if not sPlayer then _, _, itemlink = string.find(lootmsg, LOOT_SELF_REGEX) end
    	if not itemlink then self:debug("No item link") return end
    	local _, _, itemId = string.find(itemlink, "item:(%d+):")
	itemId = tonumber(itemId)
	local _, _, iQuality, _, _, _, _, _, _, _ = GetItemInfo(itemId)
	
	if iQuality < QUALITYLEVEL then self:debug("Below threshold") return end
	
	self:debug(itemlink)
	
	if not sPlayer then self:SendCommMessage("MorgDKP2MorgBid", self:Serialize("ITEMLOOTED", itemId), "RAID") end
	
	--autoclose frames if selected
	if db.autoclose and itemlist[itemId] then self:RemoveDKPFrame(itemId) end
end

function MorgBid2:UpdateFrameMedia()
	self:RemoveFrame(30988)
	self:AddItemDialog(30988, 50, 500)
	for _, data in pairs(frames) do
		self:CreateBackdrop(data.frame)
		self:UpdateFrameDimensions(data.frame)
		if data.id == 30988 and data.used then data.frame:Show() end
	end
end

function MorgBid2:UpdateResultMedia()
	local dkp = {}
	for i = 1, 80, 2 do
		dkp[i] = {{n = "Test", r = 1, g = 1, b = 1}, {n = "NEED", r = 0, g = 1, b = 0}, {n = 500, r = 0, g = 1, b = 0}}
		dkp[i+1] = {{n = "NotaTest", r = 1, g = 1, b = 1}, {n = "PASS", r = 1, g = 0, b = 0}, {n = 50, r = 1, g = 1, b = 0}}
	end
	local frame = self:GetDKPFrame(99)
	SILENT[99] = true
	self:CreateBackdrop(frame)
	self:UpdateResultFrame(frame, dkp)
	frame:Show()
end

function MorgBid2:CreateBackdrop(f)
	local db = self.db.profile
	local backdrop = f:GetBackdrop()
	if not backdrop then
		backdrop = {
			insets = {left = 3, right = 3, top = 3, bottom = 3},
			tile = false, 
			tileSize = 16, 
			edgeSize = 8,
		}
	end
	backdrop.edgeFile = media:Fetch("border", db.media.border)
	backdrop.bgFile = media:Fetch("background", db.media.background)
	f:SetBackdrop(backdrop)
	f:SetBackdropColor(unpack(db.media.backdropC))
   	f:SetBackdropBorderColor(unpack(db.media.borderC))
end

function MorgBid2:UpdateFrameDimensions(f)
	local font = media:Fetch("font", db.media.font)
	f.name:SetFont(font, db.media.fontsize + 2)
   	f.subname:SetFont(font, db.media.fontsize) 
   	f.dkp:SetFont(font, db.media.fontsize + 2) 
   	f.att:SetFont(font, db.media.fontsize) 
   	f.icon:SetWidth(26 + db.media.fontsize)
	f.icon:SetHeight(26 + db.media.fontsize)
	local width = 200 + ((db.media.fontsize - 9) * 9)
	f:SetWidth(width) 
	f.name:SetWidth(width - 42 - db.media.fontsize)
   	f:SetHeight(75 + ((db.media.fontsize - 9) * 2))
   	if f.bidbutton then f.bidbutton.text:SetFont(font, db.media.fontsize + 1) end
end

function MorgBid2:CreateResultFrame()
	local font = media:Fetch("font", db.media.resultfont)
	local edge = media:Fetch("border", db.media.border)
	local bg = media:Fetch("background", db.media.background)
	local fontsize = db.media.resultfontsize
	
	local f = CreateFrame("Frame", nil, UIParent)
	f:SetFrameStrata("FULLSCREEN")
	f:EnableMouse(1)
   	f:SetMovable(1)
   	f:SetResizable(1)
   	f:RegisterForDrag("LeftButton")
   	f:ClearAllPoints()
   	local point, relpoint, x, y = db.anchorpoint, db.anchorrelpoint, db.anchorx, db.anchory
	f:SetPoint(point, UIParent, relpoint, x, y)
  	self:debug("Anchored frame to "..point..relpoint..x..y)
  	
  	f:SetScript("OnDragStart", function(f) f:StartMoving() end) 
  	f:SetScript("OnDragStop", function(f)
   						f:StopMovingOrSizing()
   						local point, _, relativePoint, x, y = f:GetPoint()
						db.anchorpoint = point
						db.anchorrelpoint = relativePoint
						db.anchorx = math.floor(x)
						db.anchory = math.floor(y)
   					end) 
  	
  	f.title = f:CreateFontString()
   	f.title:SetPoint("TOP", f, "TOP", 0, -5)
   	f.title:SetJustifyH("CENTER")
   	f.title:SetFont(font, fontsize + 1)
   	f.title:SetTextColor(unpack(db.media.borderC))
   	f.title:SetText("test")
   	f.title:Show()
   	   	
	f.scroll = CreateFrame("ScrollFrame", nil, f)
   	f.scroll:EnableMouse(1)
   	f.scroll:ClearAllPoints()
   	f.scroll:EnableMouseWheel(1)
   	f.scroll:SetPoint("TOP", f.title, "BOTTOM", 0, -5)
   	f.scroll:SetBackdrop({ bgFile = "", tile = false, tileSize = 16, edgeFile = edge, edgeSize = 8, insets = { left = 3, right = 3, top = 3, bottom = 3 } })
	f.scroll:SetBackdropBorderColor(0, 0, 0, 1)
	f.scroll.text = {}
   	f.scroll.textid = 1
	f.scroll.textlen = 0
	f.scroll.height = 0
   	
   	f.close = CreateFrame("Button", nil, f)
   	f.close:SetScript("OnClick", function(f) self:RemoveDKPFrame(f:GetParent():GetID()) end)
   	f.close:SetWidth(24)
   	f.close:SetHeight(24)
   	f.close:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
   	f.close:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down")
   	f.close:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight")
   	f.close:ClearAllPoints()
   	f.close:SetPoint("TOPRIGHT", f, "TOPRIGHT", 0, 0)
   	f.close:SetHitRectInsets(5, 5, 5, 5)
   	f.close:Show()
   	   	
	f:SetBackdrop({ bgFile = bg, tile = false, tileSize = 16, edgeFile = edge, edgeSize = 8, insets = { left = 3, right = 3, top = 3, bottom = 3 } })
	f:SetBackdropColor(unpack(db.media.backdropC))
	f:SetBackdropBorderColor(unpack(db.media.borderC))
	f:SetScale(1.2)
	return f
end

function MorgBid2:AddTextLine(f, t1, t2, t3)
	local id = f.textid or 1
	local attach, relpoint, top
	local t2width = 0
	local t3width = 0
	local addwidth = 40
	local font = media:Fetch("font", db.media.resultfont) 
	local height = db.media.resultfontsize
	if id == 1 then 
		attach = f
		relpoint = "TOPLEFT"
		if f.title then
			local titleheight = f.title:GetStringHeight() + 5
			top = -titleheight
			f.height = f.height + titleheight
		else top = -5 end	
	else 
		attach = f.text[id-1]
		relpoint = "BOTTOMLEFT"
		top = 0
	end
	
	f.text[id] = CreateFrame("Button", nil, f)
	f.text[id]:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight")
   	f.text[id]:ClearAllPoints()
   	f.text[id]:SetPoint("TOPLEFT", attach, relpoint, 0 , top)
   	f.text[id]:SetBackdropColor(0, 0, 0, 1)
	f.text[id]:Show()
   	
   	f.text[id].text1 = f.text[id]:CreateFontString()
   	f.text[id].text1:SetPoint("LEFT", f.text[id], "LEFT", 5, 0)
   	f.text[id].text1:SetJustifyH("LEFT")
   	f.text[id].text1:SetFont(font, height)
   	f.text[id].text1:SetTextColor(t1.r, t1.g, t1.b)
   	f.text[id].text1:SetText(t1.n)
   	f.text[id].text1:Show()
   	
   	if t3 then
   		f.text[id].text2 = f.text[id]:CreateFontString()
   		f.text[id].text2:SetPoint("CENTER", f.text[id], "CENTER")
   		f.text[id].text2:SetJustifyH("CENTER")
   		f.text[id].text2:SetFont(font, height)
   		f.text[id].text2:SetTextColor(t2.r, t2.g, t2.b)
   		f.text[id].text2:SetText(t2.n)
   		f.text[id].text2:Show()
   		t2width = f.text[id].text2:GetStringWidth()
   		addwidth = addwidth + 25
   	  	
   		f.text[id].text3 = f.text[id]:CreateFontString()
   		f.text[id].text3:SetPoint("RIGHT", f.text[id], "RIGHT")
   		f.text[id].text3:SetJustifyH("RIGHT")
   		f.text[id].text3:SetFont(font, height)
   		f.text[id].text3:SetTextColor(t3.r, t3.g, t3.b)
   		f.text[id].text3:SetText(t3.n)
   		f.text[id].text3:Show()
   		t3width = f.text[id].text3:GetStringWidth()
   	else
   		f.text[id].text2 = f.text[id]:CreateFontString()
   		f.text[id].text2:SetPoint("RIGHT", f.text[id], "RIGHT")
   		f.text[id].text2:SetJustifyH("RIGHT")
   		f.text[id].text2:SetFont(font, height)
   		f.text[id].text2:SetTextColor(t2.r, t2.g, t2.b)
   		f.text[id].text2:SetText(t2.n)
   		f.text[id].text2:Show()
   		t2width = f.text[id].text2:GetStringWidth()
   		addwidth = addwidth + 25
   	end
   	local width = f.text[id].text1:GetStringWidth() + t2width + t3width + addwidth
   	if t3width == 0 then width = width + 5 end
   	if width > f.textlen then f.textlen = width end
   	f.textid = f.textid + 1
   	f.height = f.height + height
   	f.text[id]:SetHeight(height)
end

function MorgBid2:Scrollframe_Update(f, numitems, maxitems, data, direction)
	local item = f:GetParent():GetID()
	if not SILENT[item] or (BIDWAR and BIDWARSILENT[item]) then self:debug("Can't scroll") return end
	local line
	local lineplusoffset
	local change = 1
	local offset = floor(f:GetVerticalScroll() + 0.5)
	if IsControlKeyDown() then
		if direction == 1 then offset = 0
		elseif direction == -1 then offset = numitems - maxitems end
	else
		if IsShiftKeyDown() then change = 10 end
		if direction == -1 then offset = offset + change
		elseif direction == 1 then offset = offset - change end
	end
	if offset < 0 then offset = 0 
	elseif offset > (numitems - maxitems) then offset = numitems - maxitems end
	f:SetVerticalScroll(offset)
	for line = 1, maxitems do
		lineplusoffset = line + offset
		if lineplusoffset <= numitems then
			local value = data[lineplusoffset]
			local BIDdata = value[2]
			if type(BIDdata) ~= "table" then BIDdata = statustext[value[2]] end
			f.text[line].text1:SetText(value[1].n)
			f.text[line].text1:SetTextColor(value[1].r, value[1].g, value[1].b)
			f.text[line].text2:SetText(BIDdata.n)
			f.text[line].text2:SetTextColor(BIDdata.r, BIDdata.g, BIDdata.b)
			if value[3] then 
				f.text[line].text3:SetText(value[3].n)
				f.text[line].text3:SetTextColor(value[3].r, value[3].g, value[3].b)
			end
			f.text[line]:Show()
		else
			if f.text[line] then f.text[line]:Hide() end
		end
	end
end

function MorgBid2:CreateBidFrame(itemid, itemlink)
	local font = media:Fetch("font", db.media.font)
	local edge = media:Fetch("border", db.media.border)
	local bg = media:Fetch("background", db.media.background)
	local fontsize = db.media.fontsize
	
	local f = CreateFrame("Button", nil, UIParent)
    	f:EnableMouse(true)
    	f:SetFrameStrata("FULLSCREEN")
    	f:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp", "Button4Up", "Button5Up")
    	f:EnableMouseWheel(1)
	f:SetMovable(1)
	f:RegisterForDrag("LeftButton")
   	f:SetScript("OnDragStart", function(f) f:StartMoving() end)
   	f:SetScript("OnDragStop", function(f) 
   					f:StopMovingOrSizing() 
   					local p, t, v, x, y = f:GetPoint()
					db.x = math.floor(x)
					db.y = math.floor(y)
					db.point = p
					db.relpoint = v
			end)
	f:SetID(itemid)
	f.id = itemid
	f.link = itemlink
	
	f.icon = CreateFrame("Button", "MorgBidIcon", f)
	f.icon:SetWidth(26 + fontsize)
	f.icon:SetHeight(26 + fontsize)
	f.icon:ClearAllPoints()
	f.icon:SetPoint("TOPLEFT", f, "TOPLEFT", 5, -5)
	f.icon:SetScript("OnEnter", function(f)
		GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
		GameTooltip:SetHyperlink(f:GetParent().link)
	end)
	f.icon:SetScript("OnLeave", function(f) GameTooltip:Hide() end)
	f.icon:Show()
	
	f.name = f:CreateFontString(nil, "OVERLAY")
	f.name:SetFont(font, fontsize + 2)
	f.name:SetJustifyH("LEFT")
	f.name:SetHeight(20)
	f.name:ClearAllPoints()
	f.name:SetPoint("TOPLEFT", f.icon, "TOPRIGHT", 5, 0)
	
	f.subname = f:CreateFontString(nil, "OVERLAY")
	f.subname:SetFont(font, fontsize)
	f.subname:SetJustifyH("LEFT")
	f.subname:SetWidth(200)
	f.subname:SetHeight(20)
	f.subname:ClearAllPoints()
	f.subname:SetPoint("BOTTOMLEFT", f.icon, "BOTTOMRIGHT", 5, 0)
	
	f.dkp = f:CreateFontString(nil, "OVERLAY")
	f.dkp:SetFont(font, fontsize + 2)
	f.dkp:SetJustifyH("LEFT")
	f.dkp:SetWidth(200)
	f.dkp:SetHeight(20)
	f.dkp:ClearAllPoints()
	f.dkp:SetPoint("BOTTOMLEFT", f, "BOTTOMLEFT", 5, 18)

	f.att = f:CreateFontString(nil, "OVERLAY")
	f.att:SetFont(font, fontsize)
	f.att:SetJustifyH("LEFT")
	f.att:SetWidth(200)
	f.att:SetHeight(20)
	f.att:ClearAllPoints()
	f.att:SetPoint("BOTTOMLEFT", f, "BOTTOMLEFT", 5, 4)

	f.passbutton = CreateFrame("Button", nil, f)
	f.passbutton:SetWidth(32)
	f.passbutton:SetHeight(32)
	f.passbutton:ClearAllPoints()
	f.passbutton:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -5, 4)
	f.passbutton:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Up")
	f.passbutton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Highlight")
	f.passbutton:SetScale(.9)
	f.passbutton:SetScript("OnClick", function(f) self:HandleDialogAction(f:GetParent(), "PASS") end)
	f.passbutton:SetScript("OnEnter", function(f)
		if not db.hints then
			GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
			GameTooltip:SetText(format(L["%s.\nUse this option if you do not need this item"], PASS))
		end
	end)
	f.passbutton:SetScript("OnLeave", function(f) GameTooltip:Hide() end)
	f.passbutton:Show()

	if BIDWAR then
		local takeanchor = f.passbutton
		local yoffset = -3
		if OFFSPEC then
			f.takebutton = self:CreateOffspecButton(f.passbutton, f, yoffset)
			takeanchor = f.takebutton
			yoffset = 0
		end
		
		f.take = CreateFrame("Button", nil, f)
		f.take:SetWidth(32)
		f.take:SetHeight(32)
		f.take:ClearAllPoints()
		f.take:SetPoint("RIGHT", takeanchor, "LEFT", -2, yoffset)
		f.take:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Up")
		f.take:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Highlight")
		f.take:SetScale(1.1)
		f.take:SetScript("OnClick", function(f) self:HandleDialogAction(f:GetParent(), "TAKE") end)
		f.take:SetScript("OnEnter", function(f)
			if not db.hints then
				GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
				GameTooltip:SetText(format(L["%s.\nUse this option if you are able to use this item,\nbut would prefer someone else take it first.\nAlternatively use this button if you have ALREADY received loot."], TAKE))
			end
		end)
		f.take:SetScript("OnLeave", function(f) GameTooltip:Hide() end)
		f.take:Show()
		
		f.needbutton = self:CreateNeedButton(f.take, f)
		
		f.bidbutton = self:CreateBidButton(f.needbutton, f, font, fontsize)
		f.bidbutton:SetScript("OnMouseUp", function(f, button) self:HandleBidWarAction(f:GetParent(), button) end)
		f.bidbutton:SetScript("OnEnter", function(f)
			if not db.hints then
				GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
				GameTooltip:SetText(L["Mousewheel up/Left Click - Increase bid.\nMousewheel down/Right Click - decrease bid.\nSHIFT-KEY - change bid by +/-1 (or bidstep)\nALT-KEY - change bid by +/-20\nCTRL-KEY - change bid by +/-100"])
			end
		end)
	elseif TAKEBID then
		f.bidbutton = self:CreateBidButton(f.passbutton, f, font, fontsize)
		f.bidbutton:SetScript("OnMouseUp", function(f) self:HandleDialogAction(f:GetParent(), "TAKE") end)
		f.bidbutton:SetScript("OnEnter", function(f)
			if not db.hints then
				GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
				GameTooltip:SetText(format(L["Mousewheel up - Increase bid.\nMousewheel down - decrease bid.\nSHIFT-KEY - change bid by +/-1 (or bidstep)\nALT-KEY - change bid by +/-20\nCTRL-KEY - change bid by +/-100\nClick - respond %s"], TAKE))
			end
		end)
		
		f.needbutton = self:CreateNeedButton(f.bidbutton, f, -2)
	else
		local takeanchor = f.passbutton
		local yoffset = -3
		if OFFSPEC then
			f.takebutton = self:CreateOffspecButton(f.passbutton, f, yoffset)
			takeanchor = f.takebutton
			yoffset = 0
		end
		
		f.takeonspec = CreateFrame("Button", nil, f)
		f.takeonspec:SetWidth(32)
		f.takeonspec:SetHeight(32)
		f.takeonspec:ClearAllPoints()
		f.takeonspec:SetPoint("RIGHT", takeanchor, "LEFT", -2, yoffset)
		f.takeonspec:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Up")
		f.takeonspec:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Highlight")
		f.takeonspec:SetScale(1.1)
		f.takeonspec:SetScript("OnClick", function(f) self:HandleDialogAction(f:GetParent(), "TAKE") end)
		f.takeonspec:SetScript("OnEnter", function(f)
			if not db.hints then
				GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
				GameTooltip:SetText(format(L["%s.\nUse this option if you are able to use this item,\nbut would prefer someone else take it first.\nAlternatively use this button if you have ALREADY received loot."], TAKE))
			end
		end)
		f.takeonspec:SetScript("OnLeave", function(f) GameTooltip:Hide() end)
		f.takeonspec:Show()
	
		f.needbutton = self:CreateNeedButton(f.takeonspec, f)
	end
	
	f:SetBackdrop({ bgFile = bg, tile = false, tileSize = 16, edgeFile = edge, edgeSize = 16, insets = { left = 3, right = 3, top = 3, bottom = 3 } })
	f:SetBackdropColor(unpack(db.media.backdropC))
	f:SetBackdropBorderColor(unpack(db.media.borderC))
	
	local width = 200 + ((fontsize - 9) * 9)
	f:SetWidth(width) 
	f.name:SetWidth(width - 42 - fontsize)
	f:SetHeight(75 + ((fontsize - 9) * 2))
	f:SetScale(1.2)
	f:ClearAllPoints()
	local point, relpoint, x, y = db.point, db.relpoint, db.x, db.y
	f:SetPoint(point, UIParent, relpoint, x, y)
	table.insert(frames, { ["frame"] = f, ["id"] = itemid, ["bidwar"] = BIDWAR, ["takebid"] = TAKEBID, ["offspec"] = (true and OFFSPEC), ["used"] = true })
	return f
end

function MorgBid2:CreateNeedButton(anchor, parent, yoffset)
	if not yoffset then yoffset = 3 end
	local f = CreateFrame("Button", nil, parent)
	f:SetWidth(32)
	f:SetHeight(32)
	f:ClearAllPoints()
	f:SetPoint("RIGHT", anchor, "LEFT", -2, yoffset)
	f:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Up")
	f:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Highlight")
	f:SetScale(1)
	f:SetScript("OnClick", function(f) self:HandleDialogAction(f:GetParent(), "NEED") end)
	f:SetScript("OnEnter", function(f)
		if not db.hints then
			GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
			GameTooltip:SetText(format(L["%s.\nUse this option if you want this item and it is onspec."], NEED))
		end
	end)
	f:SetScript("OnLeave", function(f) GameTooltip:Hide() end)
	f:Show()
	return f
end

function MorgBid2:CreateOffspecButton(anchor, parent, yoffset)
	local f = CreateFrame("Button", nil, parent)
	f:SetWidth(32)
	f:SetHeight(32)
	f:ClearAllPoints()
	f:SetPoint("RIGHT", anchor, "LEFT", -2, yoffset)
	f:SetNormalTexture("Interface\\AddOns\\MorgBid2\\Icons\\TAKEOFFSPECALLRED")
	f:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Coin-Highlight")
	f:SetScale(1.1)
	f:SetScript("OnClick", function(f) self:HandleDialogAction(f:GetParent(), "OFFSPEC") end)
	f:SetScript("OnEnter", function(f)
		if not db.hints then
			GameTooltip:SetOwner(f, "ANCHOR_RIGHT")
			GameTooltip:SetText(format(L["%s.\nUse this option if this is an\noff-spec item but you are still interested."], OFFSPEC))
		end
	end)
	f:SetScript("OnLeave", function(f) GameTooltip:Hide() end)
	f:Show()
	return f
end

function MorgBid2:CreateBidButton(anchor, parent, font, fontsize)
	local f = CreateFrame("Button", nil, parent)
	f:EnableMouseWheel(1)
	f:SetWidth(32)
	f:SetHeight(32)
	f:ClearAllPoints()
	f:SetPoint("RIGHT", anchor, "LEFT", -2, 2)
	f:SetNormalTexture("Interface\\Buttons\\ButtonHilight-Square")
	f:SetScript("OnMouseWheel", function(f, button) self:HandleBidWarAction(f:GetParent(), button) end)
	f:SetScript("OnLeave", function(f) GameTooltip:Hide() end)
	f:Show()
	
	f.text = f:CreateFontString()
   	f.text:SetFont(font, fontsize + 1)
   	f.text:SetTextColor(0,1,0)
	f.text:ClearAllPoints()
	f.text:SetPoint("CENTER", f, "CENTER")
	f.text:SetText(bid[itemid])
	return f
end

function MorgBid2:AddItemDialog(item, points, memberdkp, isrand, needlimit)
	origbid[item] = points
	bid[item] = points
	if isrand then 
		RANDOM[item] = true 
		if isrand == 2 then WEIGHRAND = true 
		else WEIGHRAND = nil end
	end
	if needlimit then ALLOWNEED = needlimit end
	local sName, sLink, iQuality, _, iLevel, sType, sSubType, iCount, iLoc, iTexture = GetItemInfo(item)
	if not sName then 
		MemberDKP[item] = memberdkp
		self:ScanTooltip(item)
		return 
	end
	
	self:debug("Item="..(sName or "NIL").." ItemID="..(item or "NIL").." Link="..(sLink or "NIL").." Quality="..(iQuality or "NIL").." Texture="..(iTexture or "NIL"))
	
	local f = self:GetFrame(item, sLink)
	f.icon:SetNormalTexture(iTexture)
	f.name:SetText(sName)
	if not iQuality then iQuality = 2 end
	f.name:SetTextColor(unpack(Quality[iQuality + 1]))
	if points then
		f.subname:SetText(points .. L[" points"])
		f.subname:Show()
	else
		f.subname:Hide()
	end
	if memberdkp ~= "NONE" then
		dkp = memberdkp
		f.dkp:SetText("|c001eff00"..dkp)
		f.dkp:Show()
	else
		f.dkp:Hide()
	end
	f.att:SetText(ATTENDANCE.."%")
	f.att:Show()
	if BIDWAR or TAKEBID then
		f.bidbutton.text:SetText(points)
	end
	if not BIDWAR and ALLOWNEED > 0 and ATTENDANCE < ALLOWNEED then
		f.needbutton:SetAlpha(.5)
		f.needbutton:Disable()
	else
		f.needbutton:SetAlpha(1)
		f.needbutton:Enable()
	end
	f:Show()
	self:SortDialogs()
end

function MorgBid2:ScanTooltip(item)
	self:debug("Start scanning .."..item)
	if not self.Scanner then 
		self.Scanner = CreateFrame("GameTooltip", "MorgBid2_ScannerTooltip", nil, "GameTooltipTemplate")
		self.Scanner:SetOwner(UIParent, "ANCHOR_NONE")
	end
	if not SCANNING then
		self.Scanner.id = item
		self.Scanner:SetScript('OnTooltipSetItem', function() return MorgBid2:OnTooltipSetItem() end)
		SCANNING = true
		self.Scanner:SetHyperlink('item:'..item)
	else 
		tinsert(self.scanQ, item)
	end
end

function MorgBid2:OnTooltipSetItem()
	MorgBid2:debug("Returned itemlookup")
	if GetItemInfo(MorgBid2.Scanner.id) then
		MorgBid2.Scanner:SetScript('OnTooltipSetItem', nil)
		MorgBid2:AddItemDialog(MorgBid2.Scanner.id, bid[MorgBid2.Scanner.id], MemberDKP[MorgBid2.Scanner.id])
		SCANNING = nil
		if #self.scanQ > 0 then
			local scanme = self.scanQ[1]
			tremove(self.scanQ, 1)
			self:ScanTooltip(scanme)
		end
	end
end

function MorgBid2:GetFrame(item, link)
	local frame
	for i,v in ipairs(frames) do
		if not v.used and v.bidwar == BIDWAR and v.takebid == TAKEBID and v.offspec == (true and OFFSPEC) then 
			frame = v.frame
			self:debug("Reusing bidtip..."..frame.id)
			v.used = true
			v.id = item
			frame.id = item
			frame.link = link
			frame:SetID(item)
			return frame
		end
	end
	self:debug("New bidtip..."..item)
	return self:CreateBidFrame(item, link) 
end

function MorgBid2:HandleDialogAction(frame, action)
	local roll
	local realroll
	local item = frame.id
	self:RemoveFrame(item)
	if item == 30988 then return end
	self:SortDialogs() 
	if RANDOM[item] then
		RANDOM[item] = nil
		roll = math.random(100)
		if WEIGHRAND then 
			realroll = roll
			roll = ceil(roll * ATTENDANCE/100) 
			if roll < 1 then roll = 1 end
		end
	end
	if bid[item] > (dkp + overbid) then bid[item] = dkp + overbid end
	self:SendCommMessage("MorgDKP2MorgBid", self:Serialize(action, item, bid[item], roll, realroll), "RAID")
	HasBID[item] = true
	self:UpdateItemlist(itemlist[item], Player, action, roll, bid[item], item)
	if not BIDWAR then self:AddBids(item)
	elseif BIDWARSILENT[item] then BIDWARSILENT[item] = nil end
	self:SortItemList(item)
	local f = self:GetDKPFrame(item, true)
	if f and SILENT[item] then self:UpdateResultFrame(f, itemlist[item], db.bidheight) end
	--DEFAULT_CHAT_FRAME:AddMessage("MorgBid2 Action: "..action.." on item "..item.." "..bid[item])
end

function MorgBid2:RemoveFrame(itemid)
	for i,v in pairs(frames) do
		if v.used and v.id == itemid then 
			v.frame:Hide()
			v.used = nil
			break
		end
	end
	self:SortDialogs()
end

function MorgBid2:SortDialogs()
	local ct = 0
	for i,v in pairs(frames) do
		if v.used then
			v.frame:ClearAllPoints()
			v.frame:SetPoint(db.point, UIParent, db.relpoint, db.x, db.y + ct*80)
			ct = ct + 1
		end
	end
end

function MorgBid2:OnCommReceive(prefix, message, distribution, sender)
	local result, command, item, points, target, playerdkp, step, obid, silent, arg9, arg10, arg11, arg12, arg13 = self:Deserialize(message)
	if not result then return end
	if command == "QUERY" then
		if not MONITORLOOTING then
			MONITORLOOTING = true
			self:ToggleLootEvent(true)
		end
		QUALITYLEVEL = playerdkp
		BIDWAR = nil
		TAKEBID = nil
		self:UpdateMbidTable(arg9)
		local included, playerdkp, _, attendance = self:PlayerIncluded(target) 
		if included or db.alwaysresult then 
			ATTENDANCE = attendance
			SILENT[item] = silent
			HasBID[item] = not included
			if included then self:AddItemDialog(item, points, playerdkp, step, arg10) end
			self:ShowBiddingTip(target, obid, item)
		end 
	elseif command == "CHECK" then
    		self:SendCommMessage("MorgDKP2MorgBid", self:Serialize("REPLY", Player, version, versionstring), "RAID")
    		if points and version < item then self:ShowNagScreen() end
    	elseif command == "BIDWAR" then
		BIDWAR = true
		TAKEBID = nil
		if not MONITORLOOTING then
			MONITORLOOTING = true
			self:ToggleLootEvent(true)
		end
		QUALITYLEVEL = playerdkp
		bidstep = step
		overbid = obid
		self:UpdateMbidTable(arg11)
		local included, memberdkp, vote = self:PlayerIncluded(target) 
		if included or db.alwaysresult then 
			SILENT[item] = arg10
			BIDWARSILENT[item] = silent
			if vote == "PENDING" and included then self:CheckBidWarFrameUsed(item, points, memberdkp) end
			self:ShowBiddingTip(target, arg9, item)
		end
	elseif command == "TAKEBID" then
		TAKEBID = true
		BIDWAR = nil
		BIDWARSILENT[item] = nil
		if not MONITORLOOTING then
			MONITORLOOTING = true
			self:ToggleLootEvent(true)
		end
		QUALITYLEVEL = playerdkp
		bidstep = step
		overbid = obid
		mintakebid = arg12
		if points < arg12 then points = arg12 end
		self:UpdateMbidTable(arg11)
		local included, memberdkp, _, attendance = self:PlayerIncluded(target) 
		if included or db.alwaysresult then 
			ATTENDANCE = attendance
			SILENT[item] = arg10
			HasBID[item] = not included
			if included then self:AddItemDialog(item, points, memberdkp, nil, arg13) end
			self:ShowBiddingTip(target, arg9, item)
		end
	elseif command == "CLOSE" then 
		self:RemoveFrame(item) 
		self:RemoveDKPFrame(item) 
		RANDOM[item] = nil
	elseif command == "CLOSEBID" then 
		self:RemoveFrame(item) 
		SILENT[item] = true
		local f = self:GetDKPFrame(item, true)
		if f and itemlist[item] then self:UpdateResultFrame(f, itemlist[item], db.bidheight) end
	elseif command == "INITIATE" and item == Player then self:InitiateTransfer()
	elseif command == "DKPL" and item == Player then self:FormatDKPTT(command, points, target)
	end
end

function MorgBid2:OnMorgBidCommReceive(prefix, message, distribution, sender)
	if not self.db.profile.result then return end
	local result, command, item, points, roll = self:Deserialize(message)
	if command == "REPLY" or sender == Player then return end
	if command == "ITEMLOOTED" then
		self:RemoveFrame(item) 
		if db.autoclose and itemlist[item] then self:RemoveDKPFrame(item) end
		return
	end
	if command == "PASS" or command == "TAKE" or command == "NEED" or command == "OFFSPEC" then
		--self:debug("From "..sender..": "..command)
		if not itemlist[item] or (not HasBID[item] and not BIDWAR) then 
			if not otherbids[item] then otherbids[item] = {} end
			table.insert(otherbids[item], {["bid"] = command, ["bidamt"] = points, ["randroll"] = roll, ["sender"] = sender})
		end
		self:UpdateItemlist(itemlist[item], sender, command, roll, points, item)
		self:SortItemList(item)
		if SILENT[item] and not BIDWARSILENT[item] then 
			local f = self:GetDKPFrame(item, true)
			if f and itemlist[item] then self:UpdateResultFrame(f, itemlist[item], db.bidheight) end
		end
	end
end

function MorgBid2:UpdateItemlist(dkp, sender, command, roll, points, item)
	if not dkp then return end
	for i,v in pairs(dkp) do
		if v[1].n == sender then
			if TAKEBID then 
				if HasBID[item] then 
					v[2] = command
					if command == "TAKE" then v[3].n = points end
				else
					v[2] = "BID"
				end
			elseif BIDWAR then
				v[2] = command
				if  command ~= "PASS" then v[3].n = points end
			else	
				if HasBID[item] then
					v[2] = command
					if command ~= "PASS" and roll then v[3].n = roll end
				else
					v[2] = "BID"
				end
			end
			return
		end
	end
end

function MorgBid2:AddBids(id)
	if otherbids[id] then
		self:debug("Adding missed bids...")
		for _, biddata in pairs(otherbids[id]) do
			self:UpdateItemlist(itemlist[id], biddata.sender, biddata.bid, biddata.randroll, biddata.bidamt, id)
		end
		otherbids[id] = nil
	end
end

function MorgBid2:UpdateMbidTable(newterms)
	if not newterms then 
		if NEED ~= L["NEED"] then
			NEED = L["NEED"]
			TAKE = L["TAKE"]
			OFFSPEC = L["OFFSPEC"]
			PASS = L["PASS"]
			self:RestoreStatusText()
		end
	else
		NEED = newterms["NEED"]
		TAKE = newterms["TAKE"]
		PASS = newterms["PASS"]
		if newterms["OFFSPEC"] then OFFSPEC = newterms["OFFSPEC"]
		else OFFSPEC = nil end
		self:RestoreStatusText()
	end
end

function MorgBid2:SortItemList(item)
	if not item or not itemlist[item] then return end
	local qso = { ["PENDING"] = 2, ["NEED"] = 5, ["TAKE"] = 4, ["OFFSPEC"] = 3, ["PASS"] = 1, ["BID"] = 3}
	table.sort(itemlist[item], function(a,b)
    			local ao = qso[a[2]] 
    			local bo = qso[b[2]] 
    			if  ao == bo then
    				if a[4] == b[4] then
    					if a[3].n == b[3].n then
    						return a[1].n < b[1].n
    					else
    						return a[3].n > b[3].n
					end
				else
					return a[4] < b[4]
				end
			else
				return  ao > bo
			end
		end)
end

function MorgBid2:CheckBidWarFrameUsed(item, points, playerdkp)
	local found
	for i,v in pairs(frames) do
		if v.used and v.id == item then
			v.frame.bidbutton.text:SetText(points)
			origbid[item] = points
			bid[item] = points
			found = true
		end
	end
	if not found then self:AddItemDialog(item, points, playerdkp) end
end

function MorgBid2:HandleBidWarAction(frame, button)
	local id = frame:GetID()
	local origbidstep = bidstep
	local tempbid = bid[id]
	local maxbid = dkp + overbid
	if maxbid < 0 then maxbid = 0
	else
		local maxint = floor(maxbid/bidstep)
		maxbid = bidstep * maxint
	end
	if IsShiftKeyDown() then bidstep = 1 
	elseif IsAltKeyDown() then bidstep = 20 
	elseif IsControlKeyDown() then bidstep = 100 end
	if bidstep < origbidstep then bidstep = origbidstep end
	if button == 1 then tempbid = tempbid + bidstep 
	elseif button == -1 then tempbid = tempbid - bidstep 
	elseif not TAKEBID and button == "LeftButton" then tempbid = tempbid + bidstep 
	elseif not TAKEBID and button == "RightButton" then tempbid = tempbid - bidstep 
	end
	if not TAKEBID and tempbid < origbid[id] then tempbid = origbid[id] end
	if tempbid > maxbid then tempbid = maxbid 
	elseif tempbid < 0 then tempbid = 0 
	elseif TAKEBID and tempbid < mintakebid then tempbid = mintakebid end
	frame.bidbutton.text:SetText(tempbid)
	bid[id] = tempbid
	bidstep = origbidstep
end

function MorgBid2:GetDKPFrame(id, usedonly)
	--get frame reference if exists
	for num, data in ipairs(dkpframes) do
		if data.used and data.id == id then 
			self:debug("Returning frame reference..."..data.id)
			return data.frame 
		end
	end
	
	if usedonly then return nil end
	
	--if not get a no longer used already created frame
	for num, data in ipairs(dkpframes) do
		if not data.used then 
			self:debug("Resusing frame.."..data.id.." to "..id)
			data.used = true
			data.id = id
			data.frame:SetID(id)
			return data.frame
		end
	end
	
	--if not create a new frame
	local newframe = self:CreateResultFrame() 
	table.insert(dkpframes, { ["frame"] = newframe, ["id"] = id, ["used"] = true })
	newframe:SetID(id)
	self:debug("Creating new frame.."..id)
	return newframe
end

function MorgBid2:RemoveDKPFrame(id)
	self:debug("Remove DKP frame.."..(id or "NIL"))
	for num, data in ipairs(dkpframes) do
		if data.used and data.id == id then 
			data.frame:Hide()
			data.used = nil
			local scroll = data.frame.scroll
			for v = 1, scroll.textid - 1 do
    				scroll.text[v]:Hide()
    			end
    			scroll.textid = 1
			scroll.textlen = 0
			scroll.height = 0
			itemlist[id] = nil
			otherbids[id] = nil 
			break
		end
	end
	self:SortDKPFrames()
end

function MorgBid2:InitiateTransfer()
	local f = self:GetDKPFrame(98)
	f.title:SetText(L["Receiving DKP data..."])
	f:SetWidth(160)
	f:SetHeight(35)
	f.scroll:Hide()
	self:UpdateResultFrame(f)
	f:Show()
end

function MorgBid2:FormatDKPTT(command, dkp, title, quality)
	local f = self:GetDKPFrame(98)
	f.title:SetText(string.format(L["%s DKP"], title))
	f.title:SetTextColor(unpack(db.media.borderC))
	SILENT[98] = true
	self:UpdateResultFrame(f, dkp)
	f:Show()
			
end

function MorgBid2:ShowBiddingTip(dkp, title, id)
	self:debug("Show results tip..."..(id or "NIL"))
	if not db.result or (CombatLockdown and db.lockdown) then self:debug("Combat lockdown?") return end
	
	if HasBID[id] or BIDWAR then self:AddBids(id) end
	
	local font = media:Fetch("font", db.media.resultfont)
	local fontsize = db.media.resultfontsize
	local f = self:GetDKPFrame(id)
	local itemName, _, iQuality, _, _, _, _, _, _, _ = GetItemInfo(id)
	f.title:SetText(itemName)
	f.title:SetFont(font, fontsize + 1)
	if iQuality then f.title:SetTextColor(unpack(Quality[iQuality + 1])) end
	itemlist[id] = dkp
	self:SortItemList(id)
	f:Show()
	self:UpdateResultFrame(f, dkp, db.bidheight)
	self:SortDKPFrames()
end

function MorgBid2:ShowNagScreen()
	local f = self:GetDKPFrame(97)
	f.title:SetText(L["|c00FF0000OUTDATED MORGBID2!|r\n|c0000FF00Please update at\nhttp://www.wowace.com/projects/morg-bid2/|r"])
	f:SetWidth(260)
	f:SetHeight(50)
	f.scroll:Hide()
	f:Show()
	SendChatMessage("http://www.wowace.com/projects/morg-bid2/", "WHISPER", nil, Player)
end

--returns member dkp
function MorgBid2:PlayerIncluded(dkp)
	for i, v in ipairs(dkp) do
		if v[1].n == Player then
			if BIDWAR and v[5] then return true, v[5], v[2]
			else return true, v[3].n, v[2], v[5] or 0 end
		end
	end
	return false
end

function MorgBid2:SortDKPFrames()
	local lastframe
	local point = db.anchorpoint
	local relpoint = db.anchorrelpoint
	local anchor = UIParent
	local x = db.anchorx
	local y = db.anchory
	
	for i, v in ipairs(dkpframes) do
		if v.used then
			self:debug(i.." "..v.id)
			v.frame:ClearAllPoints()
			v.frame:SetPoint(point or db.media.resultpoint, anchor, relpoint or db.media.resultrelpoint, x or 0, y or 0)
			anchor = v.frame
			point, relpoint, x, y = nil, nil, nil, nil
		end
	end
end

function MorgBid2:UpdateResultFrame(f, dkp, maxitems)
	self:debug("Updating result frame...")
	if not maxitems then maxitems = db.resultheight end
	local sf = f.scroll
	
	--clear frame
	for v = 1, sf.textid-1 do
    		sf.text[v]:Hide()
    	end
	sf.textid = 1
	sf.textlen = 0
	sf.height = 0
	
	if not dkp then self:debug("DKP is nil!") return end
	
	--populate frame
	local sr, sg, sb = 1, 1, 1
	local numitems = #dkp
	if numitems < maxitems then 
		maxitems = numitems 
		sr, sg, sb = 0, 0, 0
	end
	for i = 1, numitems do
		local data = dkp[i]
		local data2 = data[2]
		if type(data2) ~= "table" then data2 = statustext[data[2]] end
		self:AddTextLine(sf, data[1], data2, data[3])
		if i == maxitems then break end
	end
	
	--position frame
	local lineheight = sf.text[1]:GetHeight()
	local width = sf.textlen + db.media.fontsize + 10
	local height = lineheight * maxitems + 10
	local titlewidth = f.title:GetWidth()
	if width < titlewidth then width = titlewidth + 15 end
	sf:SetHeight(height)
	sf:SetWidth(width + 5)
	sf:SetBackdropBorderColor(sr, sg, sb, 1)
	sf:Show()
	f:SetWidth(width + 35)
	f:SetHeight(height + f.title:GetHeight() + 30)
	for v = 1, sf.textid-1 do
    		sf.text[v]:SetWidth(width)
    	end
	
	--update frame
	sf:SetScript("OnMouseWheel", function(f, direction) self:Scrollframe_Update(f, numitems, maxitems, dkp, direction) end)
	self:Scrollframe_Update(sf, numitems, maxitems, dkp)
end